#include <ADuCM360.h>
#include "AD5270.h"
//***************************************************************************
//define
//***************************************************************************
#define SYNC_HIGH			pADI_GP1->GPOUT |= 0x80 ;
#define SYNC_LOW			pADI_GP1->GPOUT &=~ 0x80 ;

#define SCLK_HIGH			pADI_GP1->GPOUT |= 0x20 ;
#define SCLK_LOW			pADI_GP1->GPOUT &=~ 0x20 ;

#define SDIN_HIGH			pADI_GP1->GPOUT |= 0x40;
#define SDIN_LOW			pADI_GP1->GPOUT &=~ 0x40;

#define SDO     			((pADI_GP1->GPIN &0x10 ) ==0x10) ? 1 :0;
#define NOP_NUMBER		(50)
//***************************************************************************
//declaration
//***************************************************************************
void AD5270_IO_Initialize(void);
void SPI_nop(unsigned long cnt);
unsigned int SPI_Tx_16bit(unsigned int sendData);

//***************************************************************************
//***************************************************************************
void AD5270_IO_Initialize(void)
{
	pADI_GP1->GPOEN |=  0xE0;	
	SYNC_LOW;	
	SCLK_LOW;
	SDIN_LOW;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void SPI_nop(unsigned long cnt)
{
    unsigned long i=0;
    for(i=0;i<cnt;i++)
    {
        __NOP();
    }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
unsigned int SPI_Tx_16bit(unsigned int sendData)
{
     unsigned char i=0;
     unsigned char temp= 0x0000;
     unsigned int res= 0x0;

     SPI_nop(NOP_NUMBER);
     SYNC_LOW;
     SCLK_LOW;
     SPI_nop(NOP_NUMBER);

     for(i=0;i<16;i++)
     {
       SCLK_HIGH;
       if( (sendData & (1<< (15-i))) == (1<< (15-i)))
       {SDIN_HIGH;}
       else	 {SDIN_LOW;}
       SPI_nop(NOP_NUMBER);

       SCLK_LOW;

       temp=SDO;
       res |= (temp <<(15-i) );

       SPI_nop(NOP_NUMBER);
     }
     SPI_nop(NOP_NUMBER);
     SYNC_HIGH;
     return res;
}
